
class EventFinder:
    """Stores events.
    """
    def __init__(self):
        self.event_list = []
        
    def addEvent(self, node, widget, methodname):
        """Create a new event, return event_id for event.
        """
        event_list = self.event_list
        result = len(event_list)
        event_list.append((node.absolute_url(), widget.id, methodname))
        self.event_list = event_list
        return result

    def clear(self):
        """Clear all events.
        """
        self.event_list = []
        
    def find(self, event_id):
        """Handle incoming event.
        """
        # get event info
        return self.event_list[event_id]
 
