from Globals import HTMLFile
from Globals import MessageDialog
from Globals import Persistent
   
from OFS.ObjectManager import ObjectManager
from OFS import SimpleItem
from AccessControl.Role import RoleManager
from OFS.PropertyManager import PropertyManager

from Widget import Widget

class ZWidget(
    ObjectManager,
    PropertyManager,
    RoleManager,
    SimpleItem.Item,
    Widget
    ):

    meta_type = "XMLWidget"

    # the various tabs
    manage_options=(
        {'label':'Contents', 'action':'manage_main'},
        {'label':'Settings', 'action':'manage_settingsForm'},
        {'label':'Properties', 'action':'manage_propertiesForm'},
        {'label':'Security', 'action':'manage_access'},
    )

    __ac_permissions__ = (
        ('View',
         ('findWidget',
          'isNodeSupported')),
        )
    
    # settings screen
    manage_settingsForm = HTMLFile('widgetSettings', globals()) 
    
    def __init__(self, id, title, nodename):
        """Create a new widget
        """
        ZWidget.inheritedAttribute("__init__")(self, nodename)
        self.id = id
        self.title = title

    def manage_settings(self, REQUEST=None):
        """Handle result from edit action.
        REQUEST - contains other data
        """
        if REQUEST is not None:
            self.nodename = REQUEST.nodename
            message = "Properties changed"
            return self.manage_settingsForm(self, REQUEST,
                                            manage_tabs_message=message)

# form to add the Widget to a folder
manage_addWidgetForm = HTMLFile('widgetAdd', globals())

# adds Widget to folder
def manage_addWidget(self, id, title='', REQUEST=None):
    """Add widget to folder.
    """
    widget = ZWidget(id, title, REQUEST.nodename)
    
    self._setObject(id, widget)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)
